﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="Tasks.ascx.cs" Inherits="JitbitCRM.Tasks" %>

<asp:ScriptManagerProxy ID="ScriptManagerProxy1" runat="server">
	<Services>
		<asp:ServiceReference Path="~/AjaxWebService.asmx" />
	</Services>
</asp:ScriptManagerProxy>

<%--"new" box--%>
<div id="divAdd" runat="server" enableviewstate="false">
	<button type="button" id="btnShowNew" onclick="ShowNewTask()">Add a task</button><br />
	<table id="addTaskTbl" style="display:none;margin-top:4px;" width="100%" class="graphtable outerroundedbox" cellpadding="7">
	<tr><th>Add a task</th></tr>
	<tr><td class="grey">
	<asp:UpdatePanel ID="updatePanel1" runat="server">
	<ContentTemplate>
	<asp:textbox id="tbNewTask" EnableViewState="false" runat="server" Width="100%" TextMode="MultiLine" Rows="2"></asp:textbox><br/>
	When it's due?<br />
	<asp:TextBox ID="tbDueDate" CssClass="datepick" EnableViewState="false" runat="server"></asp:TextBox>
	<asp:CheckBox ID="cbSendReminder" runat="server" Text="Send reminder when due" />
	<br />
	<span id="spanProject" runat="server">Attach to a project (optional):<br /><asp:DropDownList ID="ddlProjects" runat="server" /></span>
	<div id="divContactsCompanies" runat="server">
		Attach to a company/contact (optional):<br />
		<input id="tbAttachTo" type="text" style="color:Silver" value="type for suggestions" onfocus="this.value='';this.style.color='Black';" />
		<input type="hidden" id="inputAttachToCompany" name="inputAttachToCompany" />
		<input type="hidden" id="inputAttachToContact" name="inputAttachToContact" />
	</div>
	<div>Assign to user (optional):<br /><asp:DropDownList ID="ddlUsers" runat="server" /></div>
	<div style="margin-top:7px"><asp:button id="btnAddTask" EnableViewState="false" runat="server"
		text="Add this task" onclick="btnAddTask_Click" meta:resourcekey="btnAddTaskResource1" OnClientClick="HideNewTask();return true;" />
	or <a href="javascript:HideNewTask();">Cancel</a></div>
	</ContentTemplate>
	</asp:UpdatePanel>
	</td></tr></table>
</div>


<%--list--%>
<asp:UpdatePanel ID="updatePanel2" runat="server">
<ContentTemplate>
<asp:repeater id="rptTasks" runat="server" EnableViewState="False" OnItemDataBound="rptTasks_ItemDataBound">
	<HeaderTemplate>
		<table width="100%" style="width:100%" cellpadding="7" class="taskTable">
	</HeaderTemplate>
	<ItemTemplate>
		<tr runat="server" id="trDay" visible="false">
			<td colspan="4" style="padding-left:0">
				<h3><%# Eval("DueDate") is DBNull ? "Due Date not set" : "Due on " + GetDateDayName(Eval("DueDate")) %></h3>
			</td>
		</tr>
		<tr valign="top" class="alternativeLightbg outerroundedbox">
			<td><input type="checkbox" onclick='CompleteTask("<%# Eval("TaskID") %>", this);' <%# (bool)Eval("IsCompleted") ? "checked" : "" %> /></td>
			<td style="width:100%" id='<%# Eval("TaskID") %>' class='<%# GetCssClassName(Eval("IsCompleted")) %>'>
				<div style="float:left;">
				<span id="spanTaskText<%# Eval("TaskID") %>"><%# Jitbit.Utils.StringUtils.BBCode2HTML(Eval("TaskText").ToString()) %></span>
				<span id="spanTaskDate<%# Eval("TaskID") %>" style="display:none"><%# Eval("DueDate") is DBNull ? "" : ((DateTime)Eval("DueDate")).ToString("yyyy-MM-dd")%></span>
				<span class="grey">
					<%# GetCompanyOrContactOrProjectLink(Container.DataItem)%>
					by <b><%# Eval("UserName") %></b>
					<%# Eval("AssigneeName").ToString() != ""
					? "assigned to <b>" + Eval("AssigneeName") + "</b>"
					: "" %>
					<input id='inputTaskAssignee<%# Eval("TaskID") %>' type="hidden" value="<%# Eval("AssigneeID") %>"/>
				</span>
				<br /><span class="grey taskCommentMenu"><a href="javascript:void(0)" class="commentsCountLink" onclick='$(this).hide();showComments(<%# Eval("TaskID") %>);return false;'><span class="commentsCount"><%# Eval("CommentsCount") %></span> comments</a></span>
					<div style="display:none" class='taskCommentAdd outerroundedbox taskComments<%# Eval("TaskID") %>'>
						<textarea class="taskCommentText" placeholder="Write a comment..."></textarea>
						<b class="border-notch notch"></b><b class="notch"></b>
					</div>
				</div>
			</td>
			<td class="editCell"  title="edit" onclick="EditTask(this, <%# Eval("TaskID") %>);">
				&nbsp;&nbsp;&nbsp;
			</td>
			<td class="editCal" title="iCalendar (Outlook)" onclick="ExportTaskToICalendar(<%# Eval("TaskID") %>);">&nbsp;&nbsp;&nbsp;</td>
		</tr><tr class="separator"><td colspan="3"></td></tr>
	</ItemTemplate>
	<FooterTemplate></table></FooterTemplate>
</asp:repeater>
<br />
<asp:Button ID="btnShowClosed" runat="server" EnableViewState="false" Text="Show closed tasks" onclick="btnShowClosed_Click" />
<asp:Button ID="btnHideClosed" runat="server" EnableViewState="false" Visible="false" Text="Hide closed tasks" onclick="btnHideClosed_Click" />
<br />
</ContentTemplate>
</asp:UpdatePanel>



<%--edit box--%>
<table id="tblEditTask" cellpadding="7" style="display:none;position:absolute;width:700px" class="graphtable darkbg">
<tr><th>Edit task</th></tr>
<tr><td class="grey">
<asp:UpdatePanel ID="UpdatePanel3" runat="server" RenderMode="Inline"><ContentTemplate>
<asp:TextBox runat="server" id="tbEditedTaskText" Width="100%" TextMode="MultiLine" Rows="2" /><br />
Due date:<br /><asp:TextBox runat="server" CssClass="datepick" id="tbEditedTaskDate" /><br />
Assigned to:<br /><asp:DropDownList ID="ddlUsersEditTask" runat="server"></asp:DropDownList><br />
<asp:HiddenField ID="fldEditedTaskId" runat="server" />
<asp:button ID="btnEdit" runat="server" OnClick="btnEdit_Click" OnClientClick="$('#tblEditTask').hide();return true;" Text="Save" />
<asp:button id="btnDelete" runat="server" Text="Delete" OnClick="btnDelete_Click" OnClientClick="if(confirm('Are you sure you want to delete this task?')) { $('#tblEditTask').hide();return true; } else { return false; }" />
</ContentTemplate></asp:UpdatePanel>
or <a href="javascript:void(0)" onclick="$('#tblEditTask').hide();">Cancel</a>
</td></tr>
</table>


<div id="divHelp" runat="server" class="grey" enableviewstate="false">
<br /><br />
<b>What is a task?</b> Jitbit CRM lets you create tasks, attached to your contacts, companies and projects.
Now you'll never forget to "Email contract to Barbara" or "Call John at 11am". Jitbit CRM can even send an email reminder to both the creator and the person the task is assigned to.
</div>

<script type="text/javascript">
	function AttachAutoComplete() {
		AttachAutoCompleteToInputAndHiddenInput(
			$('#tbAttachTo'),
			$('#inputAttachToContact'),
			$('#inputAttachToCompany')
		);
	}
	$(document).ready(AttachAutoComplete);
	$(function() {
	    var taskId = window.location.hash;
	    if($.trim(taskId) !== "") { //we need to expand selected task
	        showComments(taskId.substring(1));
	    }
	});
	Sys.WebForms.PageRequestManager.getInstance().add_endRequest(AttachAutoComplete);

	function CompleteTask(taskid, oCheckBox) {
		var isCompleted = oCheckBox.checked;
		if (isCompleted) {
			$('#'+taskid).addClass("linethrough").addClass("grey");
		}
		else {
			$('#'+taskid).removeClass("linethrough").removeClass("grey");
		}
		JitbitCRM.AjaxWebService.CompleteTask(taskid, isCompleted);
	}
	function ShowNewTask() {
		$("#btnShowNew").hide();
		$("#addTaskTbl").slideDown();
		$("#<%= tbNewTask.ClientID %>").focus();
	}
	function HideNewTask() {
		$("#btnShowNew").show();
		$("#addTaskTbl").hide();
	}
	function EditTask(tdElement, taskId) {
		var taskText = $('#spanTaskText' + taskId).text();
		var taskDate = $get("spanTaskDate" + taskId).innerHTML;
		var assignee = $get("inputTaskAssignee" + taskId).value;
		$get("<%= tbEditedTaskText.ClientID %>").value = taskText;
		$get("<%= tbEditedTaskDate.ClientID %>").value = taskDate;
		$get("<%= ddlUsersEditTask.ClientID %>").value = assignee;
		$get("<%= fldEditedTaskId.ClientID %>").value = taskId;
		$get("tblEditTask").style.top = $(tdElement).offset().top + "px";
		//prevent edit window from getting off limits of the screen. (it has fixed width of 700px)
		$get("tblEditTask").style.left = ($(window).width() - $(tdElement).offset().left < 700 ?$(window).width() - 700 : $(tdElement).offset().left) + "px"; 
		$("#tblEditTask").show();
	}
	function ExportTaskToICalendar(taskId) {
		window.location.replace("GetICalendarTask.ashx?TaskID=" + taskId);
	}

	<%--datepicker--%>
	$(function () {
		$(".datepick").datepicker({ gotoCurrent: true, dateFormat: "yy-mm-dd", firstDay: 1 });
	});
	function EndRequestHandler(sender, args) {
		$(".datepick").datepicker({ gotoCurrent: true, dateFormat: "yy-mm-dd", firstDay: 1 });
	}
	Sys.WebForms.PageRequestManager.getInstance().add_endRequest(EndRequestHandler);

	function showComments(taskId) {
	    var elem = $(".taskComments" + taskId);
	    elem.show();
	    $(".taskCommentText", elem).focus();
	        
	    if($(".taskCommentsList", elem).length === 0) { <%--first toggle: we need to load comments and bind events--%>
			LoadComments(taskId);
	        $(".taskCommentText", elem).keypress(function(event){
				if(event.which == 13){
					event.preventDefault();
					AddComment(taskId);
				}
			});
		}
	}
	function AddComment(taskId) {
	    var elem = $(".taskComments" + taskId);
	    var commentText = $(".taskCommentText", elem).val();
	    if($.trim(commentText) === "") {
	        $(".taskCommentText", elem).effect("highlight", {color:"#A63232"}, 500);
	        return;
	    }
	     $.ajax({
			type: "POST",
			url: "AjaxWebService.asmx/AddTaskComment",
			data: "{taskId:"+ taskId + ", body:'" + commentText+"'}",
			contentType: "application/json; charset=utf-8",
			dataType: "json",
	        success: function (msg) {
	            LoadComments(taskId);
	            $(".taskCommentText", elem).val("");
	        }
		});
	}
	
	function LoadComments(taskId) {
	    var elem = $(".taskComments" + taskId);
	    var list = $(".taskCommentsList", elem);
	    if(list.length != 0)
	        list.remove();
	    var html = "<ul class='taskCommentsList grey'>";
	            $.ajax({
					type: "POST",
					url: "AjaxWebService.asmx/getTaskComments",
					data: "{taskId:"+ taskId + "}",
					contentType: "application/json; charset=utf-8",
					dataType: "json",
					success: function(msg) {
					    $.each(msg.d, function(k, v) {
					        html += "<li><b>" + v.Username + ":</b> " + v.Body + "</li>";
					    });
					    html += "</ul>";
					    elem.prepend(html);
					}
				});
	}
</script>